# std::array<T,N>::data

From cppreference.com
< cpp‎ | container‎ | array

T* data() noexcept; |  | (until C++17)
constexpr T* data() noexcept; |  | (since C++17)
const T* data() const noexcept; |  | (until C++17)
constexpr const T* data() const noexcept; |  | (since C++17)

Returns pointer to the underlying array serving as element storage. The pointer is such that range `[data(); data() + size())` is always a valid range, even if the container is empty (`data()` is not dereferenceable in that case).

### Parameters

(none)

### Return value

Pointer to the underlying element storage. For non-empty containers, the returned pointer compares equal to the address of the first element.

### Complexity

Constant.

### Notes

If size() is 0, data() may or may not return a null pointer.

### See also

front | access the first element (public member function)
back | access the last element (public member function)
size | returns the number of elements (public member function)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/container/array/data&oldid=50435"